/**
 ****************************************************************************************************
 * @file        led.c
 * @author      ԭŶ(ALIENTEK)
 * @version     V1.0
 * @date        2020-04-17
 * @brief       LED 
 * @license     Copyright (c) 2020-2032, ӿƼ޹˾
 ****************************************************************************************************
 * @attention
 *
 * ʵƽ̨:ԭ STM32F103
 * Ƶ:www.yuanzige.com
 * ̳:www.openedv.com
 * ˾ַ:www.alientek.com
 * ַ:openedv.taobao.com
 *
 * ޸˵
 * V1.0 20200417
 * һη
 *
 ****************************************************************************************************
 */

#include "./BSP/LED/led.h"


/**
 * @brief       ʼLEDIO, ʹʱ
 * @param       
 * @retval      
 */
void led_init(void)
{
    GPIO_InitTypeDef gpio_init_struct;
    LED0_GPIO_CLK_ENABLE();                                 /* LED0ʱʹ */
    LED1_GPIO_CLK_ENABLE();                                 /* LED1ʱʹ */

    gpio_init_struct.Pin = LED0_GPIO_PIN;                   /* LED0 */
    gpio_init_struct.Mode = GPIO_MODE_OUTPUT_PP;            /*  */
    gpio_init_struct.Pull = GPIO_PULLUP;                    /*  */
    gpio_init_struct.Speed = GPIO_SPEED_FREQ_HIGH;          /*  */
    HAL_GPIO_Init(LED0_GPIO_PORT, &gpio_init_struct);       /* ʼLED0 */

    gpio_init_struct.Pin = LED1_GPIO_PIN;                   /* LED1 */
    HAL_GPIO_Init(LED1_GPIO_PORT, &gpio_init_struct);       /* ʼLED1 */
    

    LED0(1);                                                /* ر LED0 */
    LED1(1);                                                /* ر LED1 */
}
