/**
 ****************************************************************************************************
 * @file        usart.c
 * @author      ԭŶ(ALIENTEK)
 * @version     V1.0
 * @date        2020-04-20
 * @brief       ڳʼ(һǴ1)֧printf
 * @license     Copyright (c) 2020-2032, ӿƼ޹˾
 ****************************************************************************************************
 * @attention
 *
 * ʵƽ̨:ԭ STM32F103
 * Ƶ:www.yuanzige.com
 * ̳:www.openedv.com
 * ˾ַ:www.alientek.com
 * ַ:openedv.taobao.com
 *
 * ޸˵
 * V1.0 20211103
 * һη
 *
 ****************************************************************************************************
 */

#include "./SYSTEM/sys/sys.h"
#include "./SYSTEM/usart/usart.h"


/* ʹos,ͷļ. */
#if SYS_SUPPORT_OS
#include "includes.h" /* os ʹ */
#endif

/******************************************************************************************/
/* ´, ֧printf, Ҫѡuse MicroLIB */

#if 1

#if (__ARMCC_VERSION >= 6010050)            /* ʹAC6ʱ */
__asm(".global __use_no_semihosting\n\t");  /* ʹðģʽ */
__asm(".global __ARM_use_no_argv \n\t");    /* AC6ҪmainΪ޲ʽ򲿷ְ̿ܳģʽ */

#else
/* ʹAC5ʱ, Ҫﶨ__FILE  ʹðģʽ */
#pragma import(__use_no_semihosting)

struct __FILE
{
    int handle;
    /* Whatever you require here. If the only file you are using is */
    /* standard output using printf() for debugging, no file handling */
    /* is required. */
};

#endif

/* ʹðģʽҪض_ttywrch\_sys_exit\_sys_command_string,ͬʱAC6AC5ģʽ */
int _ttywrch(int ch)
{
    ch = ch;
    return ch;
}

/* _sys_exit()Աʹðģʽ */
void _sys_exit(int x)
{
    x = x;
}

char *_sys_command_string(char *cmd, int len)
{
    return NULL;
}


/* FILE  stdio.h涨. */
FILE __stdout;

/* MDKҪضfputc, printfջͨfputcַ */
int fputc(int ch, FILE *f)
{
    while ((USART_UX->SR & 0X40) == 0);     /* ȴһַ */

    USART_UX->DR = (uint8_t)ch;             /* Ҫ͵ַ ch д뵽DRĴ */
    return ch;
}
#endif
/******************************************************************************************/

#if USART_EN_RX /*ʹ˽*/

/* ջ, USART_REC_LENֽ. */
uint8_t g_usart_rx_buf[USART_REC_LEN];

/*  ״̬
 *  bit15      ɱ־
 *  bit14      յ0x0d
 *  bit13~0    յЧֽĿ
*/
uint16_t g_usart_rx_sta = 0;

uint8_t g_rx_buffer[RXBUFFERSIZE];  /* HALʹõĴڽջ */

UART_HandleTypeDef g_uart1_handle;  /* UART */

/**
 * @brief       Xʼ
 * @param       baudrate: , ԼҪòֵ
 * @note        ע: ȷʱԴ, 򴮿ڲʾͻ쳣.
 *              USARTʱԴsys_stm32_clock_init()Ѿù.
 * @retval      
 */
void usart_init(uint32_t baudrate)
{
    /*UART ʼ*/
    g_uart1_handle.Instance = USART_UX;                                       /* USART_UX */
    g_uart1_handle.Init.BaudRate = baudrate;                                  /*  */
    g_uart1_handle.Init.WordLength = UART_WORDLENGTH_8B;                      /* ֳΪ8λݸʽ */
    g_uart1_handle.Init.StopBits = UART_STOPBITS_1;                           /* һֹͣλ */
    g_uart1_handle.Init.Parity = UART_PARITY_NONE;                            /* żУλ */
    g_uart1_handle.Init.HwFlowCtl = UART_HWCONTROL_NONE;                      /* Ӳ */
    g_uart1_handle.Init.Mode = UART_MODE_TX_RX;                               /* շģʽ */
    HAL_UART_Init(&g_uart1_handle);                                           /* HAL_UART_Init()ʹUART1 */

    /* úῪжϣ־λUART_IT_RXNEýջԼջ */
    HAL_UART_Receive_IT(&g_uart1_handle, (uint8_t *)g_rx_buffer, RXBUFFERSIZE); 
}

/**
 * @brief       UARTײʼ
 * @param       huart: UARTָ
 * @note        ˺ᱻHAL_UART_Init()
 *              ʱʹܣãж
 * @retval      
 */
void HAL_UART_MspInit(UART_HandleTypeDef *huart)
{
    GPIO_InitTypeDef gpio_init_struct;

    if (huart->Instance == USART_UX)                            /* Ǵ1д1 MSPʼ */
    {
        USART_TX_GPIO_CLK_ENABLE();                             /* ʹܴTXʱ */
        USART_RX_GPIO_CLK_ENABLE();                             /* ʹܴRXʱ */
        USART_UX_CLK_ENABLE();                                  /* ʹܴʱ */

        gpio_init_struct.Pin = USART_TX_GPIO_PIN;               /* ڷź */
        gpio_init_struct.Mode = GPIO_MODE_AF_PP;                /*  */
        gpio_init_struct.Pull = GPIO_PULLUP;                    /*  */
        gpio_init_struct.Speed = GPIO_SPEED_FREQ_HIGH;          /* IOٶΪ */
        HAL_GPIO_Init(USART_TX_GPIO_PORT, &gpio_init_struct);
                
        gpio_init_struct.Pin = USART_RX_GPIO_PIN;               /* RX ģʽ */
        gpio_init_struct.Mode = GPIO_MODE_AF_INPUT;    
        HAL_GPIO_Init(USART_RX_GPIO_PORT, &gpio_init_struct);   /* RX óģʽ */
        
#if USART_EN_RX
        HAL_NVIC_EnableIRQ(USART_UX_IRQn);                      /* ʹUSART1жͨ */
        HAL_NVIC_SetPriority(USART_UX_IRQn, 3, 3);              /* 2ȼ:ռȼ3ȼ3 */
#endif
    }
}

/**
 * @brief       ݽջص
                ݴ
 * @param       huart:ھ
 * @retval      
 */
void HAL_UART_RxCpltCallback(UART_HandleTypeDef *huart)
{
    if (huart->Instance == USART_UX)                    /* Ǵ1 */
    {
        if ((g_usart_rx_sta & 0x8000) == 0)             /* δ */
        {
            if (g_usart_rx_sta & 0x4000)                /* յ0x0dس */
            {
                if (g_rx_buffer[0] != 0x0a)             /* յĲ0x0aǻм */
                {
                    g_usart_rx_sta = 0;                 /* մ,¿ʼ */
                }
                else                                    /* յ0x0aм */
                {
                    g_usart_rx_sta |= 0x8000;           /*  */
                }
            }
            else                                        /* ûյ0X0dس */
            {
                if (g_rx_buffer[0] == 0x0d)
                    g_usart_rx_sta |= 0x4000;
                else
                {
                    g_usart_rx_buf[g_usart_rx_sta & 0X3FFF] = g_rx_buffer[0];
                    g_usart_rx_sta++;

                    if (g_usart_rx_sta > (USART_REC_LEN - 1))
                    {
                        g_usart_rx_sta = 0;             /* ݴ,¿ʼ */
                    }
                }
            }
        }
    }
}

/**
 * @brief       XжϷ
                ע,ȡUSARTx->SRܱĪĴ
 * @param       
 * @retval      
 */
void USART_UX_IRQHandler(void)
{
#if SYS_SUPPORT_OS                                                   /* ʹOS */
    OSIntEnter();
#endif
    HAL_UART_IRQHandler(&g_uart1_handle);                               /* HALжϴú */

    while (HAL_UART_Receive_IT(&g_uart1_handle, (uint8_t *)g_rx_buffer, RXBUFFERSIZE) != HAL_OK)     /* ¿жϲ */
    {
        /* Ῠ */
    }

#if SYS_SUPPORT_OS                                                   /* ʹOS */
    OSIntExit();
#endif
}
#endif
