/**
 ****************************************************************************************************
 * @file        usart.h
 * @author      ԭŶ(ALIENTEK)
 * @version     V1.0
 * @date        2020-04-20
 * @brief       ڳʼ(һǴ1)֧printf
 * @license     Copyright (c) 2020-2032, ӿƼ޹˾
 ****************************************************************************************************
 * @attention
 *
 * ʵƽ̨:ԭ STM32F103
 * Ƶ:www.yuanzige.com
 * ̳:www.openedv.com
 * ˾ַ:www.alientek.com
 * ַ:openedv.taobao.com
 *
 * ޸˵
 * V1.0 20211103
 * һη
 *
 ****************************************************************************************************
 */

#ifndef __USART_H
#define __USART_H

#include "stdio.h"
#include "./SYSTEM/sys/sys.h"


/******************************************************************************************/
/*     
 * ĬUSART1.
 * ע: ͨ޸⼸궨,֧USART1~UART5һ.
 */
#define USART_TX_GPIO_PORT                  GPIOA
#define USART_TX_GPIO_PIN                   GPIO_PIN_9
#define USART_TX_GPIO_CLK_ENABLE()          do{ __HAL_RCC_GPIOA_CLK_ENABLE(); }while(0)   /* PAʱʹ */

#define USART_RX_GPIO_PORT                  GPIOA
#define USART_RX_GPIO_PIN                   GPIO_PIN_10
#define USART_RX_GPIO_CLK_ENABLE()          do{ __HAL_RCC_GPIOA_CLK_ENABLE(); }while(0)   /* PAʱʹ */

#define USART_UX                            USART1
#define USART_UX_IRQn                       USART1_IRQn
#define USART_UX_IRQHandler                 USART1_IRQHandler
#define USART_UX_CLK_ENABLE()               do{ __HAL_RCC_USART1_CLK_ENABLE(); }while(0)  /* USART1 ʱʹ */

/******************************************************************************************/

#define USART_REC_LEN               200         /* ֽ 200 */
#define USART_EN_RX                 1           /* ʹܣ1/ֹ01 */
#define RXBUFFERSIZE   1                        /* С */

extern UART_HandleTypeDef g_uart1_handle;       /* HAL UART */

extern uint8_t  g_usart_rx_buf[USART_REC_LEN];  /* ջ,USART_REC_LENֽ.ĩֽΪз */
extern uint16_t g_usart_rx_sta;                 /* ״̬ */
extern uint8_t g_rx_buffer[RXBUFFERSIZE];       /* HALUSARTBuffer */


void usart_init(uint32_t bound);                /* ڳʼ */

#endif


